<?php
/*
* MBot Custom AutoReplier PHP Script [ANSI]
* Russian language
*  2012 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* -		ID_STATUS_OFFLINE
*  		ID_STATUS_ONLINE
* 	ID_STATUS_AWAY
* 	ID_STATUS_NA
* 			ID_STATUS_OCCUPIED
*  	ID_STATUS_DND
*  	ID_STATUS_FREECHAT
* 		ID_STATUS_INVISIBLE
*/

/* CONFIGURATION */
define('SCRIPT_NAME',		'Custom AutoReplier');	// Script name.
define('SCRIPT_VERSION',	'1.0.2.0');				// Script version.
define('SCRIPT_CFG',		'MSP_AutoReplier');		// Script config section.
define('SYM_ENTER',			chr(0x0D).chr(0x0A));	// Enter
define('SAVE_SENT_MESSAGE',	true);					// Save sent message (autoreplier) on history.
define('SAVE_REC_MESSAGE',	true);					// Save received message on history.
define('MARK_AS_READ',		false);					// Mark the message as read. Not the blinking message icon on your contact list. Message window don't popup.
define('DISPLAY_POPUP',		true);					// Show a PopUp when autoreplier message is sent.
define('INCLUDE_PATH',		realpath('./') .'/mbot/scripts/include');
define('WORKING_PATH',		realpath('./') .'/mbot/scripts/autoload/AutoReplier');
define('GMT_OFFSET',		'GMT+4');				// GMT OffSet.
define('REPLY_PAUSE',		300);					// Reply pause in sec
define('WS_BORDER',			0x00800000);			// Dialog style
define('WS_EDITBOX',		3);						// Control style
/* END CONFIGURATION */

include (INCLUDE_PATH . '/conv.libphp4.php');

function mbot_load()
{
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon_miranda	= mb_IconLoadSkin(SKINICON_OTHER_MIRANDA);
		$icon_mbot		= 0;

		mb_SelfRegister(MB_EVENT_MSG_IN | MB_EVENT_MSG_OUT | MB_EVENT_MENU_COMMAND, 1);
		mb_SelfSetInfo('  v.'. SCRIPT_VERSION .' by Dionys');
		mb_Echo('  v.'. SCRIPT_VERSION .' .'. SYM_ENTER);
		mb_MenuAdd('AutoReplier Help', 0, 'HelpDlgCall', $icon_mbot);
	//	mb_SoundAddEx('autoreplier_vip', 'MBot', 'AutoReplier VIP');
	//	mb_SoundSet('autoreplier_vip', WORKING_PATH .'/autoreplier.wav');

		mt_setvar('ar_file_pass',		WORKING_PATH .'/'. 'autoreplier_pass.txt',				1, 0);
		mt_setvar('ar_file_ara',		WORKING_PATH .'/'. 'autoreplier_all.txt',				1, 0);
		mt_setvar('ar_file_online',		WORKING_PATH .'/'. 'autoreplier_online.txt',			1, 0);
		mt_setvar('ar_file_away',		WORKING_PATH .'/'. 'autoreplier_away.txt',				1, 0);
		mt_setvar('ar_file_na',			WORKING_PATH .'/'. 'autoreplier_na.txt',				1, 0);
		mt_setvar('ar_file_occup',		WORKING_PATH .'/'. 'autoreplier_occup.txt',				1, 0);
		mt_setvar('ar_file_dnd',		WORKING_PATH .'/'. 'autoreplier_dnd.txt',				1, 0);
		mt_setvar('ar_file_freechat',	WORKING_PATH .'/'. 'autoreplier_freechat.txt',			1, 0);
		mt_setvar('ar_file_invis',		WORKING_PATH .'/'. 'autoreplier_invis.txt',				1, 0);

		if(!@mb_CSettingGet(NULL, SCRIPT_CFG, 'dbg_script'))
		{
			mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'dbg_script', 0x00);
		}

		if(!file_exists(mt_getvar('ar_file_pass')))
		{
			$file_handle = @fopen(mt_getvar('ar_file_pass'), "w");
			if ($file_handle)
			{
				fwrite($file_handle, date("Ymd", time()));
				fclose($file_handle);
			}
		}
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function mbe_MsgOut($cid, $body)
{
	$uin 		= mb_CGetUIN($cid);
	$protocol	= mb_CGetProto($cid);
	$my_status	= mb_PGetMyStatus($protocol);
	$body_parts	= explode(' ', $body);
	$command	= $body_parts[0];
	$operation	= '';
	
	if (NeedDebug())
	{
		$echo = 'AR-> Command: ' . $command . SYM_ENTER;
		mb_Echo($echo . SYM_ENTER);
	}

	switch($command)
	{
		case '!help':
			HelpDlgCall($param, $cid, $hmenu);
			return 'drop';
		// create autoreplier
		case '!arc':
			$file = WORKING_PATH .'/'. 'autoreplier_'. $protocol .'_'. $uin .'.txt';
			$operation = 'create';
			break;
		case '!ara':
			$file = mt_getvar('ar_file_ara');
			$operation = 'create';
			break;
		case '!ar-online':
			$file = mt_getvar('ar_file_online');
			$operation = 'create';
			break;
		case '!ar-away':
			$file = mt_getvar('ar_file_away');
			$operation = 'create';
			break;
		case '!ar-na':
			$file = mt_getvar('ar_file_na');
			$operation = 'create';
			break;
		case '!ar-occup':
			$file = mt_getvar('ar_file_occup');
			$operation = 'create';
			break;
		case '!ar-dnd':
			$file = mt_getvar('ar_file_dnd');
			$operation = 'create';
			break;
		case '!ar-freechat':
			$file = mt_getvar('ar_file_freechat');
			$operation = 'create';
			break;
		case '!ar-invis':
			$file = mt_getvar('ar_file_invis');
			$operation = 'create';
			break;
		// delete autoreplier		
		case '!sarc':
			$file = WORKING_PATH .'/'. 'autoreplier_'. $protocol .'_'. $uin .'.txt';
			$operation = 'delete';
			break;
		case '!sara':
			$file = mt_getvar('ar_file_ara');
			$operation = 'delete';
			break;
		case '!sar-online':
			$file = mt_getvar('ar_file_online');
			$operation = 'delete';
			break;
		case '!sar-away':
			$file = mt_getvar('ar_file_away');
			$operation = 'delete';
			break;
		case '!sar-na':
			$file = mt_getvar('ar_file_na');
			$operation = 'delete';
			break;
		case '!sar-occup':
			$file = mt_getvar('ar_file_occup');
			$operation = 'delete';
			break;
		case '!sar-dnd':
			$file = mt_getvar('ar_file_dnd');
			$operation = 'delete';
			break;
		case '!sar-freechat':
			$file = mt_getvar('ar_file_freechat');
			$operation = 'delete';
			break;
		case '!sar-invis':
			$file = mt_getvar('ar_file_invis');
			$operation = 'delete';
			break;
		case '!!sar':
			$file = '*';
			$operation = 'delete';
			break;
		case '!pass':
			$file = mt_getvar('ar_file_pass');
			PasswordOperation($file, $command, $body, $cid);
			return 'drop';
	}

	switch ($operation)
	{
		case 'create':
			CreateAutoreplier($file, $command, $body, $cid);
			return 'drop';
		case 'delete':
			DeleteAutoreplier($file, $cid);
			return 'drop';
	}

	return 0;
}

function mbe_MsgIn($cid, $body, $timestamp, $known)
{
	$file_handle			= fopen(mt_getvar('ar_file_pass'), "r");
	$uin					= mb_CGetUIN($cid);
	$reg_name				= mb_CGetInfo($cid, 3);
	if($reg_name == NULL)
	{
		$reg_name			= $uin;
	}
	$name					= mb_CGetDisplayName($cid);
	if($name == NULL)
	{
		$name				= $uin;
	}
	$protocol				= mb_CGetProto($cid);
	$my_status				= mb_PGetMyStatus($protocol);
	$pass					= fread($file_handle, filesize(mt_getvar('ar_file_pass')));
	$pass_cl				= mb_CSettingGet($cid, SCRIPT_CFG, 'Pass');
	$pass_body				= utf2ansi(trim($body));

	fclose($file_handle);

	// if known contact
	if (mb_CIsOnList($cid) == 1)
	{
		// if pass accepted
		if($pass_cl == $pass || $pass_body == $pass)
		{
			if($pass_body == $pass)
			{
				mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_ASCIIZ, 'Pass', $pass_body);
				mb_MsgSend ($cid, $reg_name .'  ,   .', SAVE_SENT_MESSAGE);
//				PlaySoundVip();
			}

			return 0;
		}
		// if exist settings for contact
		else if(file_exists(WORKING_PATH .'/'. 'autoreplier_'. $protocol .'_'. $uin .'.txt'))
		{
			return Autoreply($timestamp, $cid, WORKING_PATH .'/'. 'autoreplier_'. $protocol .'_'. $uin .'.txt', '');
		}
		// if exist settings for all
		else if(file_exists(mt_getvar('ar_file_ara')))
		{
			return Autoreply($timestamp, $cid, mt_getvar('ar_file_ara'), '');
		}
		else
		{
			switch($my_status)
			{
				// if exist settings for status online
				case ID_STATUS_ONLINE:
					if (file_exists(mt_getvar('ar_file_online')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_online'), ' ');
					}
					break;
				// if exist settings for status away
				case ID_STATUS_AWAY:
					if (file_exists(mt_getvar('ar_file_away')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_away'), '');
					}
					break;
				// if exist settings for status na
				case ID_STATUS_NA:
					if (file_exists(mt_getvar('ar_file_na')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_na'), '');
					}
					break;
				// if exist settings for status occupied
				case ID_STATUS_OCCUPIED:
					if (file_exists(mt_getvar('ar_file_occup')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_occup'), '');
					}
					break;
				// if exist settings for status dnd
				case ID_STATUS_DND:
					if (file_exists(mt_getvar('ar_file_dnd')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_dnd'), ' ');
					}
					break;
				// if exist settings for status freechat
				case ID_STATUS_FREECHAT:
					if (file_exists(mt_getvar('ar_file_freechat')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_freechat'), ' ');
					}
					break;
				// if exist settings for status invisible
				case ID_STATUS_INVISIBLE:
					if (file_exists(mt_getvar('ar_file_invis')))
					{
						return Autoreply($timestamp, $cid, mt_getvar('ar_file_invis'), '');
					}
					break;
			}
		}
	}

	return 0;
}

function CreateAutoreplier($file, $command, $body, $cid)
{
	$msg = utf2ansi(substr($body, strlen($command) + 1));
	$msg_trimmed = trim($msg);
	// create autoreplier file
	if (empty($msg_trimmed))
	{
		$file_handle = @fopen($file, "r");
		if ($file_handle)
		{
			$msg = fread($file_handle, filesize($file));
			fclose($file_handle);
			if(DISPLAY_POPUP)
			{
				$msg_popup = ' :'. SYM_ENTER . $msg;
				$ico_popup = IDI_INFORMATION;
			}
		}
		else
		{
			if(DISPLAY_POPUP)
			{
				$msg_popup = ':'. SYM_ENTER . $file . SYM_ENTER .' .   !';
				$ico_popup = IDI_ERROR;
			}
		}
	}
	else
	{
		$file_handle = @fopen($file, "w");
		if ($file_handle)
		{
			fwrite($file_handle, $msg);
			fclose($file_handle);
			if(DISPLAY_POPUP)
			{
				$msg_popup = ':'. SYM_ENTER . $file . SYM_ENTER .'!';
				$ico_popup = IDI_INFORMATION;
			}
		}
		else
		{
			if(DISPLAY_POPUP)
			{
				$msg_popup = ':'. SYM_ENTER . $file . SYM_ENTER .' !';
				$ico_popup = IDI_ERROR;
			}
		}
	}

	if(DISPLAY_POPUP)
	{
		mb_PUAdd($cid, ' []', $msg_popup, NULL, NULL, mb_IconLoadSys($ico_popup));
	}
}

function DeleteAutoreplier($file, $cid)
{
	if ($file == '*')
	{
		foreach (glob(WORKING_PATH .'/*.txt') as $filename)
		{
			unlink($filename);
		}
		if(DISPLAY_POPUP)
		{
			$msg_popup = '   .';
			$ico_popup = IDI_INFORMATION;
		}
	}
	else if(file_exists($file))
	{
		unlink($file);
		if(DISPLAY_POPUP)
		{
			$msg_popup = ':'. SYM_ENTER . $file . SYM_ENTER .'!';
			$ico_popup = IDI_INFORMATION;
		}
	}
	else if(DISPLAY_POPUP)
	{
		$msg_popup = ':'. SYM_ENTER . $file . SYM_ENTER .'  !';
		$ico_popup = IDI_ERROR;
	}

	if(DISPLAY_POPUP)
	{
		mb_PUAdd($cid, ' []', $msg_popup, NULL, NULL, mb_IconLoadSys($ico_popup));
	}
}

function PasswordOperation($file, $command, $body, $cid)
{
	$msg = utf2ansi(trim(substr($body, strlen($command) + 1)));

	if(empty($msg))
	{
		$file_handle = fopen($file, "r");
		$pass = fread($file_handle, filesize($file));
		fclose($file_handle);
		if(DISPLAY_POPUP)
		{
			$msg_popup = ' :'. SYM_ENTER . $pass;
			$ico_popup = IDI_INFORMATION;
		}
	}
	else
	{
		$file_handle = fopen($file, "w");
		fwrite($file_handle, $msg);
		fclose($file_handle);
		if(DISPLAY_POPUP)
		{
			$msg_popup = '  .';
			$ico_popup = IDI_INFORMATION;
		}
	}

	if(DISPLAY_POPUP)
	{
		mb_PUAdd($cid, ' []', $msg_popup, NULL, NULL, mb_IconLoadSys($ico_popup));
	}
}

function Autoreply($timestamp, $cid, $file, $name_popup)
{
	$uin					= mb_CGetUIN($cid);
	$reg_name				= mb_CGetInfo($cid, 3);
	if($reg_name == NULL)
	{
		$reg_name			= $uin;
	}
	$name					= mb_CGetDisplayName($cid);
	if($name == NULL)
	{
		$name				= $uin;
	}

	$ignore_duration = mb_CSettingGet($cid, SCRIPT_CFG, 'IgnoreDuration');
	if($ignore_duration != NULL && $timestamp < $ignore_duration)
	{
		return 'drop';
	}

	$ignore_limit = $timestamp + REPLY_PAUSE;

	mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_DWORD, 'IgnoreDuration', $ignore_limit);

	$file_handle = fopen($file, "r");
	$msg_reply = fread($file_handle, filesize($file));
	fclose($file_handle);

	mb_MsgSend(
				$cid,
				$reg_name .'     - :'. SYM_ENTER .
				$msg_reply . SYM_ENTER .
				'     : '. date("Y.m.d H:i:s", $ignore_limit) .' ('. GMT_OFFSET .')',
				SAVE_SENT_MESSAGE
	);

	if(DISPLAY_POPUP)
	{
		mb_PUAdd($cid, " [$name_popup]", "$name  .", NULL, NULL, mb_IconLoadSys(IDI_INFORMATION));
	}

	if(SAVE_REC_MESSAGE && MARK_AS_READ)
	{
		return 'store';
	}
	else if(!SAVE_REC_MESSAGE)
	{
		return 'drop';
	}

	return 0;
}

function HelpDlgCall($param, $cid, $hmenu) 
{
	$dlg = mb_DlgCreate('AutoReplier Help', 'HelpDlgCallback', 428, 510, 0, 1);

	mb_DlgAddControl($dlg,	3,	' c: 			!help',								5, 5, 410, 18,		NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'  VIP :		!pass <>',					5, 25, 410, 18,		NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   :		!arc <>',					5, 45, 410, 18,		NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'  :				!ara <>',						5, 65, 410, 18,		NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   [ ]:		!ar-online <>',			5, 85, 410, 18,		NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:		!ar-away <>',			5, 105, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:		!ar-na <>',			5, 125, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:		!ar-occup <>',				5, 145, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   [ ]:	!ar-dnd <>',			5, 165, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   [ ]:		!ar-freechat <>',	5, 185, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:		!ar-invis <>',			5, 205, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   :		!sarc',						5, 225, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'  :			!sara',								5, 245, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   [ ]:		!sar-online',				5, 265, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:	!sar-away',					5, 285, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:	!sar-dnd',					5, 305, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:		!sar-na',					5, 325, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   [ ]:	!sar-occup',			5, 345, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   [ ]:	!sar-freechat',			5, 365, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	'   []:	!sar-invis',				5, 385, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	3,	':				!!sar',										5, 405, 410, 18,	NULL,	WS_BORDER,	1);
	mb_DlgAddControl($dlg,	1,	'*,   ,      ',	5, 425, 410, 36,	NULL,	NULL,		0);

	mb_DlgRun($dlg);
}

function HelpDlgCallback($ok, $param) 
{
	//TODO
	return 1; //cancel or close
}

/*
function PlaySoundVip()
{
	if (NeedDebug())
	{
		mb_Echo('AR-> PlaySoundVip triggered' . SYM_ENTER);
	}

	mb_SoundPlay('autoreplier_vip');
	usleep(400000); // 0.40 sec
}
*/

function NeedDebug()
{
	if(mb_CSettingGet(NULL, SCRIPT_CFG, 'dbg_script') == 0x00)
	{
		return false;
	}
	else
	{
		return true;
	}
}
?>